
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2WebExtension.Objects.DOMHTMLFieldSetElement
    ( 

-- * Exported types
    DOMHTMLFieldSetElement(..)              ,
    DOMHTMLFieldSetElementK                 ,
    toDOMHTMLFieldSetElement                ,
    noDOMHTMLFieldSetElement                ,


 -- * Methods
-- ** dOMHTMLFieldSetElementGetForm
    dOMHTMLFieldSetElementGetForm           ,




 -- * Properties
-- ** Disabled
    DOMHTMLFieldSetElementDisabledPropertyInfo,
    constructDOMHTMLFieldSetElementDisabled ,
    getDOMHTMLFieldSetElementDisabled       ,
    setDOMHTMLFieldSetElementDisabled       ,


-- ** Elements
    DOMHTMLFieldSetElementElementsPropertyInfo,
    getDOMHTMLFieldSetElementElements       ,


-- ** Form
    DOMHTMLFieldSetElementFormPropertyInfo  ,
    getDOMHTMLFieldSetElementForm           ,


-- ** Name
    DOMHTMLFieldSetElementNamePropertyInfo  ,
    constructDOMHTMLFieldSetElementName     ,
    getDOMHTMLFieldSetElementName           ,
    setDOMHTMLFieldSetElementName           ,


-- ** Type
    DOMHTMLFieldSetElementTypePropertyInfo  ,
    getDOMHTMLFieldSetElementType           ,


-- ** ValidationMessage
    DOMHTMLFieldSetElementValidationMessagePropertyInfo,
    getDOMHTMLFieldSetElementValidationMessage,


-- ** WillValidate
    DOMHTMLFieldSetElementWillValidatePropertyInfo,
    getDOMHTMLFieldSetElementWillValidate   ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2WebExtension.Types
import GI.WebKit2WebExtension.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLFieldSetElement = DOMHTMLFieldSetElement (ForeignPtr DOMHTMLFieldSetElement)
foreign import ccall "webkit_dom_html_field_set_element_get_type"
    c_webkit_dom_html_field_set_element_get_type :: IO GType

type instance ParentTypes DOMHTMLFieldSetElement = DOMHTMLFieldSetElementParentTypes
type DOMHTMLFieldSetElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLFieldSetElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_field_set_element_get_type
    

class GObject o => DOMHTMLFieldSetElementK o
instance (GObject o, IsDescendantOf DOMHTMLFieldSetElement o) => DOMHTMLFieldSetElementK o

toDOMHTMLFieldSetElement :: DOMHTMLFieldSetElementK o => o -> IO DOMHTMLFieldSetElement
toDOMHTMLFieldSetElement = unsafeCastTo DOMHTMLFieldSetElement

noDOMHTMLFieldSetElement :: Maybe DOMHTMLFieldSetElement
noDOMHTMLFieldSetElement = Nothing

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFieldSetElementDisabled :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m Bool
getDOMHTMLFieldSetElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLFieldSetElementDisabled :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> Bool -> m ()
setDOMHTMLFieldSetElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLFieldSetElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLFieldSetElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLFieldSetElementDisabledPropertyInfo
instance AttrInfo DOMHTMLFieldSetElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementDisabledPropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLFieldSetElementDisabledPropertyInfo = "DOMHTMLFieldSetElement::disabled"
    attrGet _ = getDOMHTMLFieldSetElementDisabled
    attrSet _ = setDOMHTMLFieldSetElementDisabled
    attrConstruct _ = constructDOMHTMLFieldSetElementDisabled

-- VVV Prop "elements"
   -- Type: TInterface "WebKit2WebExtension" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLFieldSetElementElements :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m DOMHTMLCollection
getDOMHTMLFieldSetElementElements obj = liftIO $ getObjectPropertyObject obj "elements" DOMHTMLCollection

data DOMHTMLFieldSetElementElementsPropertyInfo
instance AttrInfo DOMHTMLFieldSetElementElementsPropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementElementsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementElementsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementElementsPropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementElementsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLFieldSetElementElementsPropertyInfo = "DOMHTMLFieldSetElement::elements"
    attrGet _ = getDOMHTMLFieldSetElementElements
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "form"
   -- Type: TInterface "WebKit2WebExtension" "DOMHTMLFormElement"
   -- Flags: [PropertyReadable]

getDOMHTMLFieldSetElementForm :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m DOMHTMLFormElement
getDOMHTMLFieldSetElementForm obj = liftIO $ getObjectPropertyObject obj "form" DOMHTMLFormElement

data DOMHTMLFieldSetElementFormPropertyInfo
instance AttrInfo DOMHTMLFieldSetElementFormPropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementFormPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementFormPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementFormPropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementFormPropertyInfo = DOMHTMLFormElement
    type AttrLabel DOMHTMLFieldSetElementFormPropertyInfo = "DOMHTMLFieldSetElement::form"
    attrGet _ = getDOMHTMLFieldSetElementForm
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFieldSetElementName :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m T.Text
getDOMHTMLFieldSetElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLFieldSetElementName :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> T.Text -> m ()
setDOMHTMLFieldSetElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLFieldSetElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFieldSetElementName val = constructObjectPropertyString "name" val

data DOMHTMLFieldSetElementNamePropertyInfo
instance AttrInfo DOMHTMLFieldSetElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementNamePropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLFieldSetElementNamePropertyInfo = "DOMHTMLFieldSetElement::name"
    attrGet _ = getDOMHTMLFieldSetElementName
    attrSet _ = setDOMHTMLFieldSetElementName
    attrConstruct _ = constructDOMHTMLFieldSetElementName

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLFieldSetElementType :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m T.Text
getDOMHTMLFieldSetElementType obj = liftIO $ getObjectPropertyString obj "type"

data DOMHTMLFieldSetElementTypePropertyInfo
instance AttrInfo DOMHTMLFieldSetElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementTypePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementTypePropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLFieldSetElementTypePropertyInfo = "DOMHTMLFieldSetElement::type"
    attrGet _ = getDOMHTMLFieldSetElementType
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "validation-message"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLFieldSetElementValidationMessage :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m T.Text
getDOMHTMLFieldSetElementValidationMessage obj = liftIO $ getObjectPropertyString obj "validation-message"

data DOMHTMLFieldSetElementValidationMessagePropertyInfo
instance AttrInfo DOMHTMLFieldSetElementValidationMessagePropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementValidationMessagePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementValidationMessagePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementValidationMessagePropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementValidationMessagePropertyInfo = T.Text
    type AttrLabel DOMHTMLFieldSetElementValidationMessagePropertyInfo = "DOMHTMLFieldSetElement::validation-message"
    attrGet _ = getDOMHTMLFieldSetElementValidationMessage
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "will-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMHTMLFieldSetElementWillValidate :: (MonadIO m, DOMHTMLFieldSetElementK o) => o -> m Bool
getDOMHTMLFieldSetElementWillValidate obj = liftIO $ getObjectPropertyBool obj "will-validate"

data DOMHTMLFieldSetElementWillValidatePropertyInfo
instance AttrInfo DOMHTMLFieldSetElementWillValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLFieldSetElementWillValidatePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFieldSetElementWillValidatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFieldSetElementWillValidatePropertyInfo = DOMHTMLFieldSetElementK
    type AttrGetType DOMHTMLFieldSetElementWillValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLFieldSetElementWillValidatePropertyInfo = "DOMHTMLFieldSetElement::will-validate"
    attrGet _ = getDOMHTMLFieldSetElementWillValidate
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLFieldSetElement = DOMHTMLFieldSetElementAttributeList
type DOMHTMLFieldSetElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMElementChildrenPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLFieldSetElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("elements", DOMHTMLFieldSetElementElementsPropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("form", DOMHTMLFieldSetElementFormPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLFieldSetElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLFieldSetElementTypePropertyInfo), '("validation-message", DOMHTMLFieldSetElementValidationMessagePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("will-validate", DOMHTMLFieldSetElementWillValidatePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLFieldSetElement = DOMHTMLFieldSetElementSignalList
type DOMHTMLFieldSetElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLFieldSetElement::get_form
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLFieldSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLFieldSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit2WebExtension" "DOMHTMLFormElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_field_set_element_get_form" webkit_dom_html_field_set_element_get_form :: 
    Ptr DOMHTMLFieldSetElement ->           -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLFieldSetElement"
    IO (Ptr DOMHTMLFormElement)


dOMHTMLFieldSetElementGetForm ::
    (MonadIO m, DOMHTMLFieldSetElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLFormElement
dOMHTMLFieldSetElementGetForm _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_field_set_element_get_form _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_field_set_element_get_form" result
    result' <- (newObject DOMHTMLFormElement) result
    touchManagedPtr _obj
    return result'


